<?php
/*
 * dayCache implements a turns calculations of order o(k.n) into o(1) (specifically o(5n) to o(1))
 * dayCache has an exception: it is forbidden to cache current day. That is because current day is always changing.
 * dayCache works with HISTORY and the history never changes.
 * changed dayCache class by keyCache class, since the cache is also useful for different times (day,week,month,year)
 * Ok, but there is a problem: I don't know how to split between days, weeks, month and years
 * Because depending on that, we have to decide  what queries we'r going to call.
 * solutions?
 * Ideas:
 * Instead InvalidKey we pass a type: day,month, year or whatever.
 * In this way we decide what to return depending of de initial data.
 * I think this is a way better way to do this.
 * Is not enough!: when you see switch is because you need inheritance.
 */
class keyCache
{
public $visitors;
public $pageviews;
public $spiders;
public $feeds;
public $errors;
private $key;
private $keyType; //if the keys is invalid, get out

    public function __construct($key,$keyType)
    {
    $this->key=$key;
    $this->keyType=$keyType;
    }

    /*
    * returns if it is cached .If true, load the data into the properties.
    * 201200607: Introduced global. Global are general queries involving ALL records.
    * We deal with this data, splitting the results as Total=Total(yesterday) + Total (today). Total until yesterday can be cached.
    * also the key has to be different from day case.
    * The global settings has to be called using yesterday date. Calculations using today info will be ignored.
    */
    public function isCached()
    {
        //Retrieve day from metadata if exists
        //get_post_meta is a little obscure, so we deal directly with arrays instead relying in array inner working
        $keyCache=get_post_meta(utilities::statcommSummary,$this->key,true);

        //Cache rule: is date is today disallow caching
        if (empty($keyCache)) return false;
        switch ($this->keyType) {
            case "day":
                $today = gmdate('Ymd', current_time('timestamp'));
                //Rule: avoid caching if it is today
                if ($this->key==$today )
                {
                    return false;
                }
                break;
            case "month":
                $thisMonth = gmdate('Ym', current_time('timestamp'));
                //Rule:avoid caching if it is this month.
                if ($this->key ==$thisMonth)
                {
                    return false;
                }
                break;
            case "global": //special case. this global has the text 'global', prefixed. There are no exceptions
                //The global is composed by 'globalYYYYMMDD'
                //It has to be used with the YESTERDAY data NOT today. Calculation from today will be ignored
                //Well, it should be only dates on the past...

                if (substr($this->key,6) !='global') return false; //if not global key, should be ignored
                $today = gmdate('Ymd', current_time('timestamp'));
                $keyday=substr($this->key,-8); //extract from right to left
                //Calculations based on today should be ignored.Is up to the programmer to use yesterday to make calculations.
                if ($this->key == $today) return false;
                break;
           default:
               trigger_error("Type <strong>{$this->keyType}</strong> not implemented for method isCached", E_USER_ERROR);
        }
        //key cached, fetch it
        $this->visitors = $keyCache['visitors'];
        $this->pageviews = $keyCache['pageviews'];
        $this->spiders = $keyCache['spiders'];
        $this->feeds = $keyCache['feeds'];
        $this->errors = $keyCache['errors'];
        return true;
   }

    /**
    * make the cache.
    * Return true if successfully made the cache, and false if we tried to make the cache for current day.
    * @return bool
    */
    public function makeKeyCached()
    {
        $acceptedTypes=array("day","month","global");
        if(!in_array($this->keyType, $acceptedTypes))
        {
            trigger_error("Type <strong>$acceptedTypes</strong> doesn't exist", E_USER_ERROR);
        }

        $isValidKey=true;
        $mySql=new mySql();
        switch ($this->keyType) {
            case "day": //in case day the key is in the format YYYYMMDD
                $qryVisitors=  $mySql->getRow(mySql::QRY_VisitorsDay,$this->key);
                $qryPageViews= $mySql->getRow(mySql::QRY_PageViewsDay,$this->key);
                $qrySpiders=   $mySql->getRow(mySql::QRY_SpidersDay,$this->key);
                $qryFeeds=     $mySql->getRow(mySql::QRY_FeedsDaily,$this->key);
                $qryErrors=    $mySql->getRow(mySql::QRY_ErrorsDay,$this->key);
                break;
            case "month": //month: the key is in the format YYYYMM
                $qryVisitors=  $mySql->getRow(mySql::QRY_VisitorsMonth,$this->key);
                $qryPageViews= $mySql->getRow(mySql::QRY_PageViewsMonth,$this->key);
                $qrySpiders=   $mySql->getRow(mySql::QRY_SpidersMonth,$this->key);
                $qryFeeds=     $mySql->getRow(mySql::QRY_FeedsMonth,$this->key);
                $qryErrors=    $mySql->getRow(mySql::QRY_ErrorsMonth,$this->key);
                break;
            case "global": //global: the key is in the format globalYYYYMMDD
                //Extract date from key
                $keyday=substr($this->key,-8); //extract from right to left
                $qryVisitors=  $mySql->getRow(mySql::QRY_Visitors_Global,$keyday);
                $qryPageViews= $mySql->getRow(mySql::QRY_PageViews_Global,$keyday);
                $qrySpiders=   $mySql->getRow(mySql::QRY_Spiders_Global,$keyday);
                $qryFeeds=     $mySql->getRow(mySql::QRY_Feeds_Global,$keyday);
                $qryErrors=    $mySql->getRow(mySql::Qry_Errors_Global,$keyday);
                break;
            default:
                trigger_error("Type <strong>{$this->keyType}</strong> not implemented yet", E_USER_ERROR);
        }

//        if (! ($this->key==$this->keyType))
//        {
            $fields=array();
            $fields['visitors'] = $qryVisitors->visitors;
            $fields['pageviews']= $qryPageViews->pageview;
            $fields['spiders']  = $qrySpiders->spiders;
            $fields['feeds']    = $qryFeeds->feeds;
            $fields['errors']   = $qryErrors->errors;

            update_post_meta(utilities::statcommSummary, $this->key, $fields, true);
//            $isValidKey=false;
//        }
        //load data to the object but do not save it
        $this->visitors=$qryVisitors->visitors;
        $this->pageviews=$qryPageViews->pageview;
        $this->spiders=$qrySpiders->spiders;
        $this->feeds =$qryFeeds->feeds;
        $this->errors=$qryErrors->errors;

//        return $isValidKey;
    }
}
?>